<% . /usr/local/lib/cgi/haserl.sh ; check_instances uinetwork.cgi %>
<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/status.sh %>
<% . /usr/local/lib/cgi/config.sh %>
<html>
<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
<title>SIP OPUS - Settings</title>
<link href="/sys/css/settings.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="/sys/js/util.js"></script>
<script language="javascript">

var is_firefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;

/* hide html table row */
function hide_tr(id){
	el=document.getElementById(id);
	if (el) el.style.display='none';
}

/* show html table row
   Latest version of Firefox use "block" to show previously
   hidden table row when style.display='' is used in JS code
   This causes problems with select options drop down menus
   not being selectable with the mouse, so handle it
   it here differently here */
function show_tr(id){
       	el=document.getElementById(id);
	if (el){
		if (is_firefox){
			el.style.display='table-row';
            	}else{
			el.style.display='';
            	}
	}
}

function showActiveApp(activeApp){
	switch ( activeApp )  {
		case "pjsua":
			document.getElementById('pjsua').style.display = '';
			document.getElementById('simple_player').style.display = 'none';
			// Show/Hide the AEC Tail
   			var aecTypeElem=document.getElementById('aec_type');
			showHideAecTail(aecTypeElem.options[aecTypeElem.selectedIndex].value);
			break;
		case "simple_player":
			document.getElementById('pjsua').style.display = 'none';
			document.getElementById('simple_player').style.display = '';
			break;
		default:
			document.getElementById('pjsua').style.display = 'none';
			document.getElementById('simple_player').style.display = 'none';
	}
}


function checkIntInputValue(elem,minVal,maxVal,defVal)
{
	// get the entered value
	var newValue=elem.value;
	// if not set, use the default
	if ( newValue == "" ) newValue = defVal;
	// the value must be integer number
	var newValNum=parseInt(newValue, 10);
	// ... and in the range of min-max
	if ( newValNum > maxVal ) newValNum = maxVal;
	if ( newValNum < minVal ) newValNum = minVal;
	if ( newValue != newValNum ){
		elem.value = newValNum;
	}
}


function showHideFdxOpts(fdxOpt)
{
	var fdxLevelElem=document.getElementById('hdx_levl');
	var fdxToutElem=document.getElementById('hdx_tout')
	if (fdxOpt == "y"){
		fdxLevelElem.style.display = '';
		fdxToutElem.style.display = '';
	}else{
		fdxLevelElem.style.display = 'none';
		fdxToutElem.style.display = 'none';
	}
}
</script>
<style type="text/css">
<!--
body { margin-left:20px }
table {
	width:600px;
	border-spacing:5px;
}
-->
</style>
</head>
<body>

<form name="settings" action=config.cgi method=POST>
<input type=hidden name=return_page value=cgi-bin/uibasic.cgi>

<table>    
        <col style="width:120px">                                                
        <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>MAIN APPLICATION SETTINGS</b></td>
	</tr>
	<tr>
	    <td><font size=2><b>Active Application</b></font></td>
	    <td>
			<select size="1" id=active_app name="application.main_config.active_app" onChange=showActiveApp(this.value);>
            	<option value="pjsua" <% if cfg_string_compare application.main_config.active_app pjsua; then echo -n "selected"; fi %>>SIP Client</option>
        	    <option value="simple_player" <% if cfg_string_compare application.main_config.active_app simple_player; then echo -n "selected"; fi %>>Simple Player</option>
            </select>
	    </td>
	</tr>
	<tr id="dev_mode" <% if cfg_string_compare pjsua.misc.device_mode FDX; then echo -n 'style="display:none"'; fi %>>
	    <td><font size=2><b>M400 Device Mode</b></font></td>
	    <td>
			<select size="1" name="pjsua.misc.device_mode">
                <option value="DECODER" <% if cfg_string_compare pjsua.misc.device_mode DECODER; then echo -n "selected"; fi %>>Decoder</option>
        	    <option value="ENCODER" <% if cfg_string_compare pjsua.misc.device_mode ENCODER; then echo -n "selected"; fi %>>Encoder</option>
        	</select>
	    </td>
	</tr>
</table> 

<table id=pjsua <% if ! cfg_string_compare application.main_config.active_app pjsua; then echo -n 'style="display:none"'; fi %>>    
        <col style="width:120px">                                                
        <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>SIP CLIENT SETTINGS</b></td>
	</tr>
	
	<tr>
	    <td><font size=2><b>SIP Server(PBX)</b></font></td>
		<td>
			<input  name="pjsua.sip_account.registrar" size="16" maxlength="50" value="<% cfg_print_param pjsua.sip_account.registrar %>" onChange="StringCheck(this)">
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>SIP User Name</b></font></td>
		<td>
			<input  name="pjsua.sip_account.username" size="16" maxlength="50" 
                    value="<% cfg_print_param pjsua.sip_account.username %>"
                >
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>Auth User Name</b></font></td>
		<td>
			<input  name="pjsua.sip_account.authname" size="16" maxlength="50" 
                    value="<% cfg_print_param pjsua.sip_account.authname %>"
                >
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>SIP/Auth User Password</b></font></td>
		<td>
			<input  name="pjsua.sip_account.password" type=password size="16" maxlength="50" 
                    value="<% cfg_print_param pjsua.sip_account.password %>"
                >
        </td>
    </tr>













</table>

<table id=simple_player <% if ! cfg_string_compare application.main_config.active_app simple_player; then echo -n 'style="display:none"'; fi %>>    
        <col style="width:120px">                                                
        <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>SIMPLE PLAYER SETTINGS</b></td>
	</tr>
	<tr>
		<td><font size=2><b>Play MP3 File/Stream</b></font></td>
        <td><font size=2>
        	<input type="radio" name="simple_player.common.media_type"
        		value="files"
       <%  if cfg_string_compare simple_player.common.media_type files ; then echo -n "checked"; fi %>>Files
       		<input type="radio" name="simple_player.common.media_type"
        		value="stream"
       <% if cfg_string_compare simple_player.common.media_type stream ; then echo -n "checked"; fi %>>Stream
		</font>
        </td>
	</tr>
    <tr>
	    <td><font size=2><b>Media Folder Name</b></font></td>
		<td>
			<input  name="simple_player.files.media_folder" 
					size="16" maxlength="50" 
                    value="<% cfg_print_param simple_player.files.media_folder %>"
                >
        </td>
    </tr>
    <tr>
	    <td><font size=2><b>Stream URL</b></font></td>
		<td>
			<input  name="simple_player.streaming.url"
					size="65" maxlength="80" 
                    value="<% cfg_print_param simple_player.streaming.url%>"
                >
        </td>
    </tr>
    <tr>
    <td><font size=2><b>RTP Stream Buffer</b></font></td>
   	<td>
        <font size=2>
            <input name="simple_player.streaming.buffer_ms" 
                size="5" maxlength="5" 
                value="<% cfg_print_param simple_player.streaming.buffer_ms %>"
                onchange="checkIntInputValue(this,10,1000,300);"
            >&nbsp;ms
        </font>
    </td>
</tr> 
</table>

</form>
</body>
</html>
