<% . /usr/local/lib/cgi/haserl.sh ; check_instances uidefaults.cgi %>
<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/config.sh %>
<%
function print_media_options()
{
# detect SD card, assuming it is always one, and with one partition, 
# and possibly multiple usb sticks with multiple partitions

    MEDIA_DIR=$(cat /etc/ferdinand.conf | sed -n -e "s/^storage_media=//p")
    DISK_SIZES=$(lsblk -o KNAME,SIZE)
    NUM_DISKS=$(lsblk -o name | grep -c -e '-sd')
    MOUNT_POINTS=$(lsblk -o KNAME,MOUNTPOINT)
	
    for disk in /sys/block/* ;do
        is_usb=0
        udev_name=$(basename $disk)
        if  [ -f $disk/removable ] && [ $(<$disk/removable) -gt 0 ] 
        then
        	is_usb=1
        else
# 		some USB chipsets do not report the removable bit, check with udevadm       	
        	if udevadm info --query=all --name="$udev_name" | grep ID_BUS | grep -Fxiq usb
        	then 
        		is_usb=1
        	fi
        fi
        if [ "$is_usb" -gt 0 ] && [ -f $disk/size ] && [ $(<$disk/size) -gt 0 ]
        then
# find usb stick partitions
            for syspart in $disk/sd* ; do
                part=$(basename $syspart)
                dev_name="/dev/$part"
                echo "<option value=$dev_name>USB stick ("
                echo "$DISK_SIZES" | grep -i "$part" | awk '{print $2;}' 
                if mount | grep -Fq "$dev_name" 
                then
                    if [ "$NUM_DISKS" -gt 1 ]
                    then
                        echo ", "
                        echo "$MOUNT_POINTS" | grep -i "$part" | awk '{print $2;}'                        
                    else
                        echo ", mounted"
                    fi
                    if mount | grep "$dev_name" | grep -Fq "$MEDIA_DIR" 
                    then
                        echo ", in use"
                    fi
                else
                    echo ", not mounted"
                fi
                echo ")</option>"
            done
        else
            if echo "$disk" | grep -Fq "mmcblk0"
            then 
# we assume the SD card has only one partition
                dev_name="/dev/mmcblk0p1" 
                echo "<option value=$dev_name selected>SD Card ("
                lsblk -o KNAME,SIZE | grep -i "mmcblk0p1" | awk '{print $2;}' 
                if mount | grep -Fq "$dev_name" 
                then
                    echo ", mounted"
                    if mount | grep "$dev_name" | grep -Fq "$MEDIA_DIR" 
                    then
                        echo ", in use"
                    fi
                else
                    echo ", not mounted"
                fi
                echo ")</option>"
            fi
        fi
    done
}
%>
<html>
<head>
<link href="/sys/css/basic.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--
td.wrn {
    width:480px; 
    border:2px solid red;
    background-color: #ffff77;
    font-size: 12px;
    font-weight: bold;
}
img.cmd {
  width: 0px;
  height: 0px;
  visibility: hidden;
}
-->
</style>

<script type="text/javascript">
function autoresize(id) {
    var autoheight=300;
    if (document.getElementById){
        autoheight=document.getElementById(id).contentWindow.document .body.scrollHeight;
    }
    document.getElementById(id).height= (autoheight) + 30 + "px";
}
function required() {
	var fn = document.getElementById('filename').value;
    
	if(fn=="") {
		alert("Please select a file to upload.");
		return false;
        }
	return true;
};
function sendUpdCmd(){
    document.getElementById('send_cmd_img').src='/cgi-bin/command.cgi?deffor=1';
}

function sendFormatCmd(theCmdType){
	var ret=false;
	var fix_errors=document.getElementById('fix_fs').checked;
	if (theCmdType == "fmt"){
		ret=confirm("! ! ! ! !   A T T E N T I O N   ! ! ! ! !\n\nThis will stop the playback and erase all data on the selected media!\nAre you sure you want to continue ?");
	}else{
		if (fix_errors == true){
			ret=confirm("! ! ! ! !   A T T E N T I O N   ! ! ! ! !\n\nRunning file system check with the \"Fix errors\" option enabled will stop the playback\nand may modify the data on the selected media!\nAre you sure you want to continue  ?");
		}else{
			ret=confirm("! ! ! ! !   A T T E N T I O N   ! ! ! ! !\n\nThis will stop the playback if the selected media is in use!\nAre you sure you want to continue ?");
		}
	}
    if (ret == true){
        // hide the controls so that you cannot click Format again
        document.getElementById('format_div').style.display='none';
        fmtCmd="/cgi-bin/format.cgi?format=";
        fmtCmd=fmtCmd+document.getElementById('fs_select').value;
        fmtCmd=fmtCmd+","+document.getElementById('media_select').value;
        // send the FS check options if the FS button pressed
		if (theCmdType == "chk"){
			if (fix_errors == true){
				fmtCmd=fmtCmd+",err_fix";
			}else{
				fmtCmd=fmtCmd+",no_err_fix";
			}
		}
        // hide all other options and show the warning
        document.getElementById('non_format').style.display='none';
        document.getElementById('format_warning').style.display="";
        fmt_frame=document.getElementById('fmt_iframe');
        fmt_frame.style.display="";
        fmt_frame.src=fmtCmd;
    }
}

function selectMedia(theMedia){
    var selectOpt=document.getElementById('fs_select');
    if (theMedia.indexOf("mmc") !=-1){
        selectOpt.options[1].disabled=true;
 //       selectOpt.options[2].disabled=true;
        selectOpt.options[0].selected=true;
    }else{
        selectOpt.options[1].disabled=false;
 //       selectOpt.options[2].disabled=false;
    }
}

</script>
</head> 
<body>
<br>
<b>FACTORY DEFAULTS</b><p>

<%
# first handle if return page is not set
if [ "$FORM_return_page"X = "X" ] ; then FORM_return_page="/index.html"; 
fi

if [ "$FORM_confirm"X = "true"X ] ; then 
	rv=`/sbin/uci get security.defaults.enabled`
	if [[ $rv == "true" ]] ; then
		cfg_restore_soft_defaults	

		echo '
<p>Settings successfully reverted to factory defaults.<p>
	'
	fi
else
	echo -n '
<div id=non_format>
<p>Reverts all settings <!--except "Network configuration"--> to factory defaults.
<form action="'
	echo -n $SCRIPT_NAME
	echo '" method="get">
<input type="hidden" name="confirm" value="true">
  <tr>
	<input type=submit value=" Reset Factory Defaults " '
		if [ "$(/sbin/uci -q get security.defaults.enabled)" == "false" ] ; then echo "disabled"; fi
	echo -n '
	> 
  </tr>
</form>
</div>
<!--
<div id=format_warning style="display:none">
<table width="440">
<tr>
<td class="wrn">
    <center><br>
    <div style="display: inline-block; text-align: center;">
        <img src="/sys/images/warning.png" />
        <font color=black>&nbsp;&nbsp;WARNING&nbsp;&nbsp;</font>
        <img src="/sys/images/warning.png" />
    </div><br><br>&nbsp;Please do not navigate away from this web page or close the browser <br>
while the media formatting or the file system check is in progress !<br>
</td>
</tr>
</table>
</div>

<div id=format_div>
<p><hr width="40%" align="left">
<p>Format USB or microSD.
<form id="format_media" action=format.cgi method=POST>
<input type=hidden name=return_page value=cgi-bin/uidefaults.cgi>
  <tr>
    <td>
        <select size="1" width="140px" name="media_select" id="media_select" onChange=selectMedia(this.value);> '
             print_media_options

echo -n '
        </select>
    </td>
    <td> to 
        <select size="1" width="140px" name="fs_select" id="fs_select">
            <option value="ext4" "selected" id="opt_ext4">EXT4 </option>
            <option value="vfat" id="opt_fat" disabled>FAT32 </option>
        </select>
    </td>
  </tr><br><br>
  <tr>
    <td>
        <input type="button" 
            title="Format the selected storage media" 
                value="Format"
        onclick=sendFormatCmd("fmt");
        >
    	<input type="button" 
            title="Perform file system check on the selected storage media" 
                value="Check FS"
        onclick=sendFormatCmd("chk");
        >
        <input type="checkbox" id="fix_fs" name="fix_fs" checked>Fix errors
    </td>
    <img class="cmd" id="send_fmtcmd_img" src="">
  </tr>
</form>
</div>
<iframe src="" name="fmt_iframe" id="fmt_iframe" style="display:none" width="440" height="300"></iframe>
	-->'
fi
%>
</body>
</html>

